{
Vollstaendig: JA
Syntaktisch : NEIN
Ausgetestet : NEIN
Bemerkungen :

  !!!  Um das Modul fuer den XSC-C-Precompiler zu verwenden, muessen  !!!
  !!!  alle Kommentare
  !!!                ($on)     nach   $on
  !!!                ($off)    nach   $off
  !!!                ($XSC-C   nach   ($XSC-C)
  !!!                XSC-C$)   nach   (XSC-C$)
  !!!  geaendert werden. Die andere Richtung gilt sinngemaess.
  !!!  Dabei stehen hierin die runden Klammern fuer die eigentlichen Kommentarklammern
  !!!  ( welche innerhalb dieses Kommentares nicht verwendet werden koennen ).
  !!!  Achtung: Keine geschachtelten Kommentare erzeugen !!!
}
 
MODULE mv_ari;          {  reelle Matrizen und Vektoren,  Stand : 22.04.91  }
 
{$XSC-C}
   use iostd;
{XSC-C$}

$off 
 
PROCEDURE _MATH_ERROR ( errornr : INTEGER ); EXTERNAL;

PROCEDURE m_MATH_ERROR ( errornr : INTEGER );
BEGIN
   _MATH_ERROR( errornr );
END;
 
$on

{******************************************************************}
{                                                                  }
{      PASCAL-SC ARITHMETIC ERRORHANDLER VERSION 1.0               }
{                                                                  }
{******************************************************************}

{$XSC-C}

procedure traceback (var t:text) ; external f_back ;
const   stderr = 2 ; { standard error }
procedure rewrite (var t : text ; nr : integer) ; external f_rwrn ;
procedure exit    (retcode : integer)           ; external a_exit ;
 
global  { m_math_error must be global because used by mvi_ari and mvc_ari }
procedure m_math_error (errnr : integer) ;
  var message : text;
  begin
    rewrite(message,stderr);
    case  errnr  of
      201: writeln (message,'vectors of unequal dimension') ;
      202: writeln (message,'matrices of unequal dimension') ;
      203: writeln (message,'illegal dimensions in ''matrix*vector''') ;
      204: writeln (message,'illegal dimensions in ''matrix*matrix''') ;
     else: writeln (message,'Unknown error') ;
    end ;
    traceback (message) ;
    exit(-1);
  end ;
 
 
{XSC-C$} 
 
{---------------------------------------------------------------------------}
{ 0. Vereinbarungen                                                         }
{---------------------------------------------------------------------------}
 
 
 
$off

GLOBAL TYPE RVECTOR = GLOBAL DYNAMIC ARRAY [*] OF REAL; 
            RMATRIX = GLOBAL DYNAMIC ARRAY [*] OF RVECTOR; 
 
$on 
 
 
 
{---------------------------------------------------------------------------}
{ 1. Transferfunktionen                                                     }
{---------------------------------------------------------------------------}
{    1.0 Zuweisungen                                                        }
{---------------------------------------------------------------------------}
 
 
 
 
GLOBAL OPERATOR := ( VAR A : RVECTOR; B : REAL );
 
VAR i : INTEGER;
 
BEGIN
  FOR i:= LB(A) TO UB(A) DO A[i]:= B
END;
 
 
 
 
GLOBAL OPERATOR := ( VAR A : RMATRIX; B : REAL );
 
VAR i : INTEGER;
    h : RVECTOR[LB(A,2)..UB(A,2)];
 
BEGIN
  FOR i:= LB(A,2) TO UB(A,2) DO  h[i]:= B;
  FOR i:= LB(A,1) TO UB(A,1) DO  A[i]:= h;
END;
 
 
 
 
 
{---------------------------------------------------------------------------}
{    1.0 eigentliche Transferfunktionen                                     }
{---------------------------------------------------------------------------}
 
 
 
 
         {--------  werden keine benoetigt  ----------}
 
 
 
 
{---------------------------------------------------------------------------}
{ 2. Spezielle Funktionen                                                   }
{---------------------------------------------------------------------------}
{    2.1 Transponierte                                                      }
{---------------------------------------------------------------------------}
 
 
GLOBAL FUNCTION TRANSP ( VAR A : RMATRIX ) : RMATRIX [LB(A,2)..UB(A,2),
                                                      LB(A,1)..UB(A,1)];
VAR i : INTEGER;
 
BEGIN
  FOR i:= LB(A,2) TO UB(A,2) DO  TRANSP[i]:= RVECTOR( A[*,i] )
END;
 
 
 
 
{---------------------------------------------------------------------------}
{    2.2 Null - Arrays                                                      }
{---------------------------------------------------------------------------}
{        2.2.1 Null - Vektoren                                              }
{---------------------------------------------------------------------------}
 
 
 
 
 
GLOBAL FUNCTION VNULL ( DIM : INTEGER ) : RVECTOR [1..DIM];
 
VAR i : INTEGER;
 
BEGIN
  FOR i:= 1 TO DIM DO VNULL[i]:= 0.0
END;
 
 
 
 
GLOBAL FUNCTION NULL ( VAR A : RVECTOR ) : RVECTOR [LB(A)..UB(A)];
 
VAR i : INTEGER;
 
BEGIN
  FOR i:= LB(A) TO UB(A) DO NULL[i]:= 0.0
END;
 
 
 
 
{---------------------------------------------------------------------------}
{        2.2.2 Null - Matrizen                                              }
{---------------------------------------------------------------------------}
 
 
 
 
GLOBAL FUNCTION NULL ( DIM : INTEGER ) : RMATRIX [1..DIM,1..DIM];
 
VAR i : INTEGER;
    h : RVECTOR[1..DIM];
 
BEGIN
  FOR i:= 1 TO DIM DO     h[i]:= 0.0;
  FOR i:= 1 TO DIM DO  NULL[i]:= h;
END;
 
 
 
 
GLOBAL FUNCTION NULL ( DIM1, DIM2 : INTEGER ) : RMATRIX [1..DIM1,1..DIM2];
 
VAR i : INTEGER;
    h : RVECTOR[1..DIM2];
 
BEGIN
  FOR i:= 1 TO DIM2 DO     h[i]:= 0.0;
  FOR i:= 1 TO DIM1 DO  NULL[i]:= h;
END;
 
 
 
 
GLOBAL FUNCTION NULL ( VAR A : RMATRIX ) : RMATRIX [LB(A,1)..UB(A,1),
                                                    LB(A,2)..UB(A,2)];
VAR i : INTEGER;
    h : RVECTOR[LB(A,2)..UB(A,2)];
 
BEGIN
  FOR i:= LB(A,2) TO UB(A,2) DO     h[i]:= 0.0;
  FOR i:= LB(A,1) TO UB(A,1) DO  NULL[i]:= h;
END;
 
 
 
 
GLOBAL FUNCTION NULL ( VAR A,B : RMATRIX ) : RMATRIX [LB(A,1)..UB(A,1),
                                                      LB(B,2)..UB(B,2)];
VAR i : INTEGER;
    h : RVECTOR[LB(B,2)..UB(B,2)];
 
BEGIN
  FOR i:= LB(B,2) TO UB(B,2) DO     h[i]:= 0.0;
  FOR i:= LB(A,1) TO UB(A,1) DO  NULL[i]:= h;
END;
 
 
 
 
{---------------------------------------------------------------------------}
{    2.3 Einheitsmatrizen                                                   }
{---------------------------------------------------------------------------}
 
 
 
 
GLOBAL FUNCTION ID ( DIM : INTEGER ) : RMATRIX [1..DIM,1..DIM];
 
VAR i : INTEGER;
    h : RVECTOR[1..DIM];
 
BEGIN
  FOR i:= 1 TO DIM DO h[i]:= 0.0;
  FOR i:= 1 TO DIM DO BEGIN
                         ID[ i ]:= h;
                         ID[i,i]:= 1.0;
                      END;
END;
 
 
 
 
GLOBAL FUNCTION ID ( DIM1, DIM2 : INTEGER ) : RMATRIX [1..DIM1,1..DIM2];
 
VAR i : INTEGER;
    h : RVECTOR[1..DIM2];
 
BEGIN
  FOR i:= 1 TO DIM2 DO   h[i]:= 0.0;
  FOR i:= 1 TO DIM1 DO  ID[i]:= h;           { Ganze Matrix mit 0 fuellen.}
 
  IF DIM1<DIM2 THEN  FOR i:= 1 TO DIM1 DO  ID[i,i]:= 1.0
               ELSE  FOR i:= 1 TO DIM2 DO  ID[i,i]:= 1.0;
END;
 
 
 
 
GLOBAL FUNCTION ID ( VAR A : RMATRIX ) : RMATRIX [LB(A,1)..UB(A,1),
                                                  LB(A,2)..UB(A,2)];
VAR i,bl1,bl2,bu1,bu2,d : INTEGER;
    h : RVECTOR[LB(A,2)..UB(A,2)];
 
BEGIN
  bl1:= LB(A,1);  bu1:= UB(A,1);
  bl2:= LB(A,2);  bu2:= UB(A,2);
 
  d:= bl2 - bl1;
 
  FOR i:= bl2 TO bu2 DO   h[i]:= 0.0;
  FOR i:= bl1 TO bu1 DO  ID[i]:= h;   { Ganze Matrix mit 0 fuellen. }
 
  IF ( bu2-bl2 ) < ( bu1-bl1 ) THEN  FOR i:= bl2 TO bu2 DO  ID[i-d,i]:= 1.0
                               ELSE  FOR i:= bl1 TO bu1 DO  ID[i,i+d]:= 1.0;
END;
 
 
 
GLOBAL FUNCTION ID ( VAR A,B : RMATRIX ) : RMATRIX [LB(A,1)..UB(A,1),
                                                    LB(B,2)..UB(B,2)];
VAR i,bl1,bl2,bu1,bu2,d : INTEGER;
    h : RVECTOR[LB(B,2)..UB(B,2)];
 
BEGIN
  bl1:= LB(A,1);  bu1:= UB(A,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);
 
  d:= bl2 - bl1;
 
  FOR i:= bl2 TO bu2 DO   h[i]:= 0.0;
  FOR i:= bl1 TO bu1 DO  ID[i]:= h;   { Ganze Matrix mit 0 fuellen. }
 
  IF ( bu2-bl2 ) < ( bu1-bl1 ) THEN  FOR i:= bl2 TO bu2 DO  ID[i-d,i]:= 1.0
                               ELSE  FOR i:= bl1 TO bu1 DO  ID[i,i+d]:= 1.0;
END;
 
 
 
 
{---------------------------------------------------------------------------}
{ 3. Vergleiche                                                             }
{---------------------------------------------------------------------------}
{    3.1. Vergleiche von Vektoren untereinander                             }
{---------------------------------------------------------------------------}
{SEKTOR  V33                                                                }
{---------------------------------------------------------------------------}
 
 
 
 
GLOBAL OPERATOR = ( VAR A, B : RVECTOR ) EQVRVR : BOOLEAN;
 
VAR gleich      : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;
 
BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);
 
  d:= bl - al;
 
  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
        i := al;
    gleich:= TRUE;
    WHILE  gleich  AND ( i <= au ) DO
      IF A[i] = B[i+d] THEN      i:= SUCC(i)
                       ELSE gleich:= FALSE;
    EQVRVR:= gleich
  END
END;
 
 
 
 
GLOBAL OPERATOR <> ( VAR A, B : RVECTOR ) NEVRVR : BOOLEAN;
 
VAR ungleich    : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;
 
BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);
 
  d:= bl - al;
 
  IF ( au - al ) <> ( bu - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
          i := al;
    ungleich:= FALSE;
    REPEAT
      IF A[i] <> B[i+d] THEN ungleich:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  ungleich  OR ( i > au );
    NEVRVR:= ungleich
  END
END;
 
 
 
 
GLOBAL OPERATOR <= ( VAR A, B : RVECTOR ) LEVRVR : BOOLEAN;
 
VAR kleinergleich : BOOLEAN;
    i,d,
    al,au,bl,bu   : INTEGER;
 
BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);
 
  d:= bl - al;
 
  IF ( au - al ) <> ( bu - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
               i := al;
    kleinergleich:= TRUE;
    WHILE kleinergleich AND ( i <= au ) DO
      IF A[i] <= B[i+d] THEN             i:= SUCC(i)
                        ELSE kleinergleich:= false;
    LEVRVR:= kleinergleich
  END;
END;
 
 
 
 
GLOBAL OPERATOR < ( VAR A, B : RVECTOR ) LTVRVR : BOOLEAN;
 
BEGIN
  LTVRVR:= ( A <= B ) AND ( A <> B )
END;
 
 
 
 
GLOBAL OPERATOR >= ( VAR A, B : RVECTOR ) GEVRVR : BOOLEAN;
 
VAR groessergleich    : BOOLEAN;
    i,d,
    al,au,bl,bu    : INTEGER;
 
BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);
 
  d:= bl - al;
 
  IF ( au - al ) <> ( bu - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
                i := al;
    groessergleich:= TRUE;
    WHILE groessergleich AND ( i <= au ) DO
      IF A[i] >= B[i+d]  THEN              i:= SUCC(i)
                         ELSE groessergleich:= false;
    GEVRVR:= groessergleich
  END;
END;
 
 
 
 
GLOBAL OPERATOR > ( VAR A, B : RVECTOR ) GTVRVR : BOOLEAN;
 
BEGIN
  GTVRVR:= ( A >= B ) AND ( A <> B )
END;
 
 
 
 
{---------------------------------------------------------------------------}
{    3.2 Vergleiche von Matrizen untereinander                              }
{---------------------------------------------------------------------------}
{SEKTOR V55                                                                 }
{---------------------------------------------------------------------------}
 
 
 
 
GLOBAL OPERATOR = ( VAR A, B : RMATRIX ) EQMRMR : BOOLEAN;
 
VAR gleich      : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;
 
BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);
 
  d:= bl1 - al1;
 
  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
        i := al1;
    gleich:= TRUE;
    WHILE  gleich  AND ( i <= au1 ) DO
      IF A[i] = B[i+d] THEN       i:= SUCC(i)
                       ELSE  gleich:= FALSE;
    EQMRMR:= gleich
  END
END;
 
 
 
 
GLOBAL OPERATOR <> ( VAR A, B : RMATRIX ) NEMRMR : BOOLEAN;
 
VAR ungleich    : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;
 
BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);
 
  d:= bl1 - al1;
 
  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
           i:= al1;
    ungleich:= FALSE;
    REPEAT
      IF A[i] <> B[i+d] THEN ungleich:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  ungleich OR ( i > au1 );
    NEMRMR:= ungleich
  END
END;
 
 
 
 
GLOBAL OPERATOR <= ( VAR A, B : RMATRIX ) LEMRMR : BOOLEAN;
 
VAR kleinergleich : BOOLEAN;
    i,d,
    al1,au1,bl1   : INTEGER;
 
BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);
 
  d:= bl1 - al1;
 
  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
               i := al1;
    kleinergleich:= TRUE;
    WHILE  kleinergleich AND ( i <= au1 ) DO
      IF A[i] <= B[i+d] THEN             i:= SUCC(i)
                        ELSE kleinergleich:= false;
    LEMRMR:= kleinergleich
  END;
END;
 
 
 
 
GLOBAL OPERATOR < ( VAR A, B : RMATRIX ) LTMRMR : BOOLEAN;
 
BEGIN
  LTMRMR:= ( A <= B ) AND ( A <> B )
END;
 
 
 
 
GLOBAL OPERATOR  >= ( VAR A, B : RMATRIX ) GEMRMR : BOOLEAN;
 
VAR groessergleich : BOOLEAN;
    i,d,
    al1,au1,bl1   : INTEGER;
 
BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);
 
  d:= bl1 - al1;
 
  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
                i := al1;
    groessergleich:= TRUE;
    WHILE  groessergleich AND ( i <= au1 ) DO
      IF A[i] >= B[i+d]  THEN              i:= SUCC(i)
                         ELSE groessergleich:= false;
    GEMRMR:= groessergleich
  END;
END;
 
 
 
 
GLOBAL OPERATOR  > ( VAR A, B : RMATRIX ) GTMRMR : BOOLEAN;
 
BEGIN
  GTMRMR:= ( A >= B ) AND ( A <> B )
END;
 
 
 
 
{---------------------------------------------------------------------------}
{ 4. Arithmetische Operatoren                                               }
{---------------------------------------------------------------------------}
{    4.1 Monadische Operatoren                                              }
{---------------------------------------------------------------------------}
{        4.1.1 Monadische Operatoren fuer Vektoren                          }
{---------------------------------------------------------------------------}
{SEKTOR A03                                                                 }
{---------------------------------------------------------------------------}
 
 
 
 
GLOBAL OPERATOR + ( VAR A : RVECTOR ) PLUSVR : RVECTOR [LB(A)..UB(A)];
BEGIN
  PLUSVR:= A
END;
 
 
 
 
GLOBAL OPERATOR - ( VAR A : RVECTOR ) MINUSVR : RVECTOR [LB(A)..UB(A)];
 
VAR i : INTEGER;
 
BEGIN
  FOR i:= LB(A) TO UB(A) DO MINUSVR[i]:= -A[i]
END;
 
 
 
 
{---------------------------------------------------------------------------}
{        4.1.2 Monadische Operatoren fuer Matrizen                          }
{---------------------------------------------------------------------------}
{SEKTOR A05                                                                 }
{---------------------------------------------------------------------------}
 
 
 
 
GLOBAL OPERATOR + ( VAR A : RMATRIX ) PLUSMR : RMATRIX [LB(A,1)..UB(A,1),
                                                        LB(A,2)..UB(A,2)];
BEGIN
  PLUSMR:= A
END;
 
 
 
 
GLOBAL OPERATOR - ( VAR A : RMATRIX ) MINUSMR : RMATRIX [LB(A,1)..UB(A,1),
                                                         LB(A,2)..UB(A,2)];
 
VAR z,s : INTEGER;
 
BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  MINUSMR[z,s]:= -A[z,s]
END;
 
 
 
 
{---------------------------------------------------------------------------}
{    4.2 Operatoren fuer Argumente REAL mit RVECTOR                         }
{---------------------------------------------------------------------------}
{SEKTOR A13                                                                 }
{---------------------------------------------------------------------------}
 
 
 
 
GLOBAL OPERATOR * ( A : REAL; VAR B : RVECTOR )
                                         MULRVR : RVECTOR [LB(B)..UB(B)];
VAR i : INTEGER;
 
BEGIN
  FOR i:= LB(B) TO UB(B) DO  MULRVR[i]:= A * B[i]
END;
 
 
 
 
GLOBAL OPERATOR *< ( A : REAL; VAR B : RVECTOR )
                                     MULDOWNRVR : RVECTOR [LB(B)..UB(B)];
VAR i : INTEGER;
 
BEGIN
  FOR i:= LB(B) TO UB(B) DO  MULDOWNRVR[i]:= A *< B[i]
END;
 
 
 
 
GLOBAL OPERATOR *> ( A : REAL; VAR B : RVECTOR )
                                       MULUPRVR : RVECTOR [LB(B)..UB(B)];
VAR i : INTEGER;
 
BEGIN
  FOR i:= LB(B) TO UB(B) DO  MULUPRVR[i]:= A *> B[i]
END;
 
 
 
 
{---------------------------------------------------------------------------}
{    4.3 Operatoren fuer Argumente REAL mit RMATRIX                         }
{---------------------------------------------------------------------------}
{SEKTOR A15                                                                 }
{---------------------------------------------------------------------------}
 
 
 
 
GLOBAL OPERATOR * ( A : REAL; VAR B : RMATRIX )
                                         MULRMR : RMATRIX [LB(B,1)..UB(B,1),
                                                           LB(B,2)..UB(B,2)];
VAR z,s : INTEGER;
 
BEGIN
  FOR z:= LB(B,1) TO UB(B,1) DO
  FOR s:= LB(B,2) TO UB(B,2) DO   MULRMR[z,s]:= A * B[z,s]
END;
 
 
 
 
GLOBAL OPERATOR *< ( A : REAL; VAR B : RMATRIX )
                                     MULDOWNRMR : RMATRIX [LB(B,1)..UB(B,1),
                                                           LB(B,2)..UB(B,2)];
VAR z,s : INTEGER;
 
BEGIN
  FOR z:= LB(B,1) TO UB(B,1) DO
  FOR s:= LB(B,2) TO UB(B,2) DO   MULDOWNRMR[z,s]:= A *< B[z,s]
END;
 
 
 
 
GLOBAL OPERATOR *> ( A : REAL; VAR B : RMATRIX )
                                       MULUPRMR : RMATRIX [LB(B,1)..UB(B,1),
                                                           LB(B,2)..UB(B,2)];
VAR z,s : INTEGER;
 
BEGIN
  FOR z:= LB(B,1) TO UB(B,1) DO
  FOR s:= LB(B,2) TO UB(B,2) DO   MULUPRMR[z,s]:= A *> B[z,s]
END;
 
 
 
 
{---------------------------------------------------------------------------}
{    4.4 Operatoren fuer Argumente RVECTOR mit REAL                         }
{---------------------------------------------------------------------------}
{SEKTOR A31                                                                 }
{---------------------------------------------------------------------------}
 
 
 
 
GLOBAL OPERATOR * ( VAR A : RVECTOR; B : REAL )
                                        MULVRR : RVECTOR [LB(A)..UB(A)];
VAR i : INTEGER;
 
BEGIN
  FOR i:= LB(A) TO UB(A) DO  MULVRR[i]:= A[i] * B
END;
 
 
 
 
GLOBAL OPERATOR *< ( VAR A : RVECTOR; B : REAL )
                                     MULDOWNVRR : RVECTOR [LB(A)..UB(A)];
VAR i : INTEGER;
 
BEGIN
  FOR i:= LB(A) TO UB(A) DO  MULDOWNVRR[i]:= A[i] *< B
END;
 
 
 
 
GLOBAL OPERATOR *> ( VAR A : RVECTOR; B : REAL )
                                       MULUPVRR : RVECTOR [LB(A)..UB(A)];
VAR i : INTEGER;
 
BEGIN
  FOR i:= LB(A) TO UB(A) DO  MULUPVRR[i]:= A[i] *> B
END;
 
 
 
 
GLOBAL OPERATOR / ( VAR A : RVECTOR; B : REAL )
                                        DIVVRR : RVECTOR[LB(A)..UB(A)];
VAR i : integer;
 
BEGIN
  FOR i:= LB(A) TO UB(A) DO  DIVVRR[i]:= A[i] / B
END;
 
 
 
 
GLOBAL OPERATOR /< ( VAR A : RVECTOR; B : REAL )
                                     DIVDOWNVRR : RVECTOR[LB(A)..UB(A)];
VAR i : integer;
 
BEGIN
  FOR i:= LB(A) TO UB(A) DO  DIVDOWNVRR[i]:= A[i] /< B
END;
 
 
 
 
GLOBAL OPERATOR /> ( VAR A : RVECTOR; B : REAL )
                                       DIVUPVRR : RVECTOR[LB(A)..UB(A)];
VAR i : integer;
 
BEGIN
  FOR i:= LB(A) TO UB(A) DO  DIVUPVRR[i]:= A[i] /> B
END;
 
 
 
 
{---------------------------------------------------------------------------}
{    4.5 Operatoren fuer Argumente RVECTOR mit RVECTOR                      }
{---------------------------------------------------------------------------}
{SEKTOR A33                                                                 }
{---------------------------------------------------------------------------}
 
 
 
 
GLOBAL OPERATOR + ( VAR A, B : RVECTOR ) ADDVRVR : RVECTOR [LB(A)..UB(A)];
 
VAR i, al,bl,au, d : INTEGER;
 
BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);
 
   d:= bl - al;
 
  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  ADDVRVR[i]:= A[i] + B[i+d]
END;
 
 
 
 
GLOBAL OPERATOR - ( VAR A, B : RVECTOR ) SUBVRVR : RVECTOR [LB(A)..UB(A)];
 
VAR i, al,bl,au, d : INTEGER;
 
BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);
 
   d:= bl - al;
 
  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  SUBVRVR[i]:= A[i] - B[i+d]
END;
 
 
 
 
GLOBAL OPERATOR * ( VAR A, B : RVECTOR ) MULVRVR : REAL;
 
VAR i, al,bl,au, d : INTEGER;
 
BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);
 
   d:= bl - al;
 
  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
    MULVRVR:= #*( FOR i:= al TO au SUM ( A[i] * B[i+d] ) )
END;
 
 
 
 
GLOBAL OPERATOR +< ( VAR A, B : RVECTOR ) ADDDOWNVRVR : RVECTOR [LB(A)..UB(A)];
 
VAR i, al,bl,au, d : INTEGER;
 
BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);
 
   d:= bl - al;
 
  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
    FOR i:= al TO au DO   ADDDOWNVRVR[i]:= A[i] +< B[i+d]
END;
 
 
 
 
GLOBAL OPERATOR -< ( VAR A, B : RVECTOR ) SUBDOWNVRVR : RVECTOR [LB(A)..UB(A)];
 
VAR i, al,bl,au, d : INTEGER;
 
BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);
 
   d:= bl - al;
 
  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
    FOR i:= al TO au DO  SUBDOWNVRVR[i]:= A[i] -< B[i+d]
END;
 
 
 
 
GLOBAL OPERATOR *< ( VAR A, B : RVECTOR ) MULDOWNVRVR : REAL;
 
VAR i, al,bl,au, d : INTEGER;
 
BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);
 
   d:= bl - al;
 
  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
    MULDOWNVRVR:= #<( FOR i:= al TO au SUM ( A[i] * B[i+d] ) )
END;
 
 
 
 
GLOBAL OPERATOR +> ( VAR A, B : RVECTOR ) ADDUPVRVR : RVECTOR [LB(A)..UB(A)];
 
VAR i, al,bl,au, d : INTEGER;
 
BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);
 
   d:= bl - al;
 
  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
    FOR i:= al TO au DO  ADDUPVRVR[i]:= A[i] +> B[i+d]
END;
 
 
 
 
GLOBAL OPERATOR -> ( VAR A, B : RVECTOR ) SUBUPVRVR : RVECTOR [LB(A)..UB(A)];
 
VAR i, al,bl,au, d : INTEGER;
 
BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);
 
   d:= bl - al;
 
  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
    FOR i:= al TO au DO  SUBUPVRVR[i]:= A[i] -> B[i+d]
END;
 
 
 
 
GLOBAL OPERATOR *> ( VAR A, B : RVECTOR ) MULUPVRVR : REAL;
 
VAR i, al,bl,au, d : INTEGER;
 
BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);
 
   d:= bl - al;
 
  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
    MULUPVRVR:= #>( FOR i:= al TO au SUM ( A[i] * B[i+d] ) )
END;
 
 
 
 
{---------------------------------------------------------------------------}
{    4.6 Operatoren fuer Argumente RMATRIX mit REAL                         }
{---------------------------------------------------------------------------}
{SEKTOR A51                                                                 }
{---------------------------------------------------------------------------}
 
 
 
 
GLOBAL OPERATOR * ( VAR A : RMATRIX; B : REAL )
                                       MULMRR : RMATRIX [LB(A,1)..UB(A,1),
                                                         LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;
 
BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  MULMRR[z,s]:= A[z,s] * B
END;
 
 
 
 
GLOBAL OPERATOR *< ( VAR A : RMATRIX; B : REAL )
                                     MULDOWNMRR : RMATRIX [LB(A,1)..UB(A,1),
                                                           LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;
 
BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  MULDOWNMRR[z,s]:= A[z,s] *< B
END;
 
 
 
 
GLOBAL OPERATOR *> ( VAR A : RMATRIX; B : REAL )
                                       MULUPMRR : RMATRIX [LB(A,1)..UB(A,1),
                                                           LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;
 
BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  MULUPMRR[z,s]:= A[z,s] *> B
END;
 
 
 
 
GLOBAL OPERATOR / ( VAR A : RMATRIX; B : REAL )
                                        DIVMRR : RMATRIX [LB(A,1)..UB(A,1),
                                                          LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;
 
BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  DIVMRR[z,s]:= A[z,s] / B
END;
 
 
 
 
GLOBAL OPERATOR /< ( VAR A : RMATRIX; B : REAL )
                                     DIVDOWNMRR : RMATRIX [LB(A,1)..UB(A,1),
                                                           LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;
 
BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  DIVDOWNMRR[z,s]:= A[z,s] /< B
END;
 
 
 
 
GLOBAL OPERATOR /> ( VAR A : RMATRIX; B : REAL )
                                       DIVUPMRR : RMATRIX [LB(A,1)..UB(A,1),
                                                           LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;
 
BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  DIVUPMRR[z,s]:= A[z,s] /> B
END;
 
 
 
 
{---------------------------------------------------------------------------}
{    4.7 Operatoren fuer Argumente RMATRIX mit RVECTOR                      }
{---------------------------------------------------------------------------}
{SEKTOR A53                                                                 }
{---------------------------------------------------------------------------}
 
 
 
 
GLOBAL OPERATOR * ( VAR A : RMATRIX;  VAR B : RVECTOR )
                                       MULMRVR : RVECTOR [LB(A,1)..UB(A,1)];
VAR i : INTEGER;
 
BEGIN
  IF  ( UB(A,2) - LB(A,2) <> UB(B) - LB(B) )  THEN  m_MATH_ERROR ( 203 )
  ELSE
    FOR i:= LB(A,1) TO UB(A,1) DO   MULMRVR[i]:= A[i] * B
END;
 
 
 
 
GLOBAL OPERATOR *< ( VAR A : RMATRIX; VAR B : RVECTOR )
                                   MULDOWNMRVR : RVECTOR [LB(A,1)..UB(A,1)];
VAR i : INTEGER;
 
BEGIN
  IF ( UB(A,2) - LB(A,2) <> UB(B) - LB(B) ) THEN  m_MATH_ERROR ( 203 )
  ELSE
    FOR i:= LB(A,1) TO UB(A,1) DO  MULDOWNMRVR[i]:= A[i] *< B
END;
 
 
 
 
GLOBAL OPERATOR *> ( VAR A : RMATRIX; VAR B : RVECTOR )
                                      MULUPMRVR : RVECTOR [LB(A,1)..UB(A,1)];
VAR i : INTEGER;
 
BEGIN
  IF ( UB(A,2) - LB(A,2) <> UB(B) - LB(B) ) THEN  m_MATH_ERROR ( 203 )
  ELSE
    FOR i:= LB(A,1) TO UB(A,1) DO  MULUPMRVR[i]:= A[i] *> B
END;
 
 
 
 
{---------------------------------------------------------------------------}
{    4.8 Operatoren fuer Argumente RMATRIX mit RMATRIX                      }
{---------------------------------------------------------------------------}
{SEKTOR A55                                                                 }
{---------------------------------------------------------------------------}
 
 
 
 
GLOBAL OPERATOR + ( VAR A, B : RMATRIX ) ADDMRMR : RMATRIX [LB(A,1)..UB(A,1),
                                                            LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;
 
BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);
 
   d1:= bl1 - al1;
   d2:= bl2 - al2;
 
  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  ADDMRMR[z,s]:= A[z,s] + B[z+d1,s+d2]
END;
 
 
 
 
GLOBAL OPERATOR - ( VAR A, B : RMATRIX ) SUBMRMR : RMATRIX [LB(A,1)..UB(A,1),
                                                            LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;
 
BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);
 
   d1:= bl1 - al1;
   d2:= bl2 - al2;
 
  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  SUBMRMR[z,s]:= A[z,s] - B[z+d1,s+d2]
END;
 
 
 
 
GLOBAL OPERATOR * ( VAR A, B : RMATRIX ) MULMRMR : RMATRIX [LB(A,1)..UB(A,1) ,
                                                            LB(B,2)..UB(B,2)];
VAR z,s : INTEGER;
 
BEGIN
  IF ( UB(A,2) - LB(A,2) <> UB(B,1) - LB(B,1) )  THEN  m_MATH_ERROR ( 204 )
  ELSE
    FOR z:= LB(A,1) TO UB(A,1) DO
    FOR s:= LB(B,2) TO UB(B,2) DO  MULMRMR[z,s]:= A[z] * RVECTOR( B[*,s] )
END;
 
 
 
 
GLOBAL OPERATOR +< ( VAR A, B : RMATRIX )
                              ADDDOWNMRMR : RMATRIX [LB(A,1)..UB(A,1),
                                                     LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;
 
BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);
 
   d1:= bl1 - al1;
   d2:= bl2 - al2;
 
  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  ADDDOWNMRMR[z,s]:= A[z,s] +< B[z+d1,s+d2]
END;
 
 
 
 
GLOBAL OPERATOR -< ( VAR A, B : RMATRIX )
                              SUBDOWNMRMR : RMATRIX [LB(A,1)..UB(A,1),
                                                     LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;
 
BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);
 
   d1:= bl1 - al1;
   d2:= bl2 - al2;
 
  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  SUBDOWNMRMR[z,s]:= A[z,s] -< B[z+d1,s+d2]
END;
 
 
 
 
GLOBAL OPERATOR *< ( VAR A, B : RMATRIX )
                              MULDOWNMRMR : RMATRIX [LB(A,1)..UB(A,1) ,
                                                     LB(B,2)..UB(B,2)];
VAR z,s : INTEGER;
 
BEGIN
  IF ( UB(A,2) - LB(A,2) <> UB(B,1) - LB(B,1) ) THEN  m_MATH_ERROR ( 204 )
  ELSE
    FOR z:= LB(A,1) TO UB(A,1) DO
    FOR s:= LB(B,2) TO UB(B,2) DO MULDOWNMRMR[z,s]:= A[z] *< RVECTOR(B[*,s])
END;
 
 
 
 
GLOBAL OPERATOR +> ( VAR A, B : RMATRIX )
                                ADDUPMRMR : RMATRIX [LB(A,1)..UB(A,1),
                                                     LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;
 
BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);
 
   d1:= bl1 - al1;
   d2:= bl2 - al2;
 
  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  ADDUPMRMR[z,s]:= A[z,s] +> B[z+d1,s+d2]
END;
 
 
 
 
GLOBAL OPERATOR -> ( VAR A, B : RMATRIX )
                                SUBUPMRMR : RMATRIX [LB(A,1)..UB(A,1),
                                                     LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;
 
BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);
 
   d1:= bl1 - al1;
   d2:= bl2 - al2;
 
  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  SUBUPMRMR[z,s]:= A[z,s] -> B[z+d1,s+d2]
END;
 
 
 
 
GLOBAL OPERATOR *> ( VAR A, B : RMATRIX )
                               MULUPMRMR : RMATRIX [LB(A,1)..UB(A,1) ,
                                                    LB(B,2)..UB(B,2)];
VAR z,s : INTEGER;
BEGIN
  IF ( UB(A,2) - LB(A,2) <> UB(B,1) - LB(B,1) ) THEN  m_MATH_ERROR ( 204 )
  ELSE
    FOR z:= LB(A,1) TO UB(A,1) DO
    FOR s:= LB(B,2) TO UB(B,2) DO  MULUPMRMR[z,s]:= A[z] *> RVECTOR(B[*,s])
END;
 
 
 
 
{---------------------------------------------------------------------------}
{ 5. Ein- / Ausgabe                                                         }
{---------------------------------------------------------------------------}
 
 
 
 
GLOBAL PROCEDURE READ  ( VAR F : TEXT; VAR A : RVECTOR );
 
VAR i : INTEGER;
 
BEGIN
  FOR i:= LB(A) TO UB(A) DO READ( F, A[i] )
END;
 
 
 
 
GLOBAL PROCEDURE WRITE ( VAR F : TEXT; VAR A : RVECTOR );
 
VAR i : INTEGER;
 
BEGIN
  WRITELN( F );
  FOR i:= LB(A) TO UB(A) DO WRITELN( F, A[i] )
END;
 
 
 
 
GLOBAL PROCEDURE READ  ( VAR F : TEXT; VAR A : RMATRIX );
 
VAR z, s : INTEGER;
 
BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO   READ( F, A[z,s] );
END;
 
 
 
 
GLOBAL PROCEDURE WRITE ( VAR F : TEXT; A : RMATRIX );
 
VAR z, s : INTEGER;
 
BEGIN
  WRITELN( F );
  FOR z:= LB(A,1) TO UB(A,1) DO
  BEGIN
    FOR s:= LB(A,2) TO UB(A,2) DO  WRITELN( F, A[z,s] );
    WRITELN( F )
  END
END;
 
 
END. { of module MV_ARI }
